#include<stdio.h>
#include<stdlib.h>
#include<string.h>

#include "driver.h"
#include "cpuintrf.h"
#include "memory.h"
#include "z80/z80.h"
#include "cz80.h"


cz80_struc *mame4all_cz80_struc;

#include "memory.h"



/*************************************************/
/**  Start MAME interface for cz80              **/
/*************************************************/
void cz80_reset(void *param)
{
	unsigned *ctx=(unsigned *)(((unsigned)cpu_getcontext(cpu_getactivecpu())));
	printf("Z80_Reset %i\n",cpu_getactivecpu());
	if (param)
	    debug_printf("!!! cz80 Z80_DaisyChain not implementated yet !!!");
	mame4all_cz80_struc=(cz80_struc *)&ctx[4];

	Cz80_Init(mame4all_cz80_struc);
	Cz80_Reset(mame4all_cz80_struc);

	ctx[0]=(unsigned)Cz80_Get_PC(mame4all_cz80_struc);
}

unsigned int cz80_get_pc(void)
{
	return Cz80_Get_PC(mame4all_cz80_struc);
}

void cz80_set_context(void *src)
{
	if( src )
	    mame4all_cz80_struc = *(cz80_struc*)src;
	change_pc(Cz80_Get_PC(mame4all_cz80_struc));
}

unsigned cz80_get_context(void *dst)
{
	if( dst )
	    *(cz80_struc*)dst = mame4all_cz80_struc;
	return sizeof(cz80_struc);

}

int cz80_execute(int cycles)
{
	return Cz80_Exec(mame4all_cz80_struc,cycles);
}

void cz80_exit(void)
{
}

void cz80_set_pc(unsigned val)
{
	Cz80_Set_PC(mame4all_cz80_struc, val);
}

unsigned cz80_get_sp(void)
{
	return Cz80_Get_SP(mame4all_cz80_struc);
}

void cz80_set_sp(unsigned val)
{
	Cz80_Set_SP(mame4all_cz80_struc, val);
}

unsigned cz80_get_reg(int regnum)
{
    switch( regnum )
    {
	case Z80_PC: return Z80.PC.w.l;
	case Z80_SP: return mame4all_cz80_struc.SP.W;
	case Z80_AF: return mame4all_cz80_struc.FA.W;
	case Z80_BC: return mame4all_cz80_struc.BC.W;
	case Z80_DE: return mame4all_cz80_struc.DE.W;
	case Z80_HL: return mame4all_cz80_struc.HL.W;
	case Z80_IX: return mame4all_cz80_struc.IX.W;
	case Z80_IY: return mame4all_cz80_struc.IY.W;
	case Z80_R: return mame4all_cz80_struc.R.B.L;
	case Z80_I: return mame4all_cz80_struc.I;
	case Z80_AF2: return mame4all_cz80_struc.FA2.W;
	case Z80_BC2: return mame4all_cz80_struc.BC2.W;
	case Z80_DE2: return mame4all_cz80_struc.DE2.W;
	case Z80_HL2: return mame4all_cz80_struc.HL2.W;
	case Z80_IM: return mame4all_cz80_struc.IM;
	case Z80_IFF1: return mame4all_cz80_struc.IFF;
	case Z80_IFF2: return Z80.IFF2;
	case Z80_HALT: return Z80.HALT;
	case Z80_NMI_STATE: return Z80.nmi_state;
	case Z80_IRQ_STATE: return Z80.irq_state;
	case Z80_DC0: return Z80.int_state[0];
	case Z80_DC1: return Z80.int_state[1];
	case Z80_DC2: return Z80.int_state[2];
	case Z80_DC3: return Z80.int_state[3];
	case REG_PREVIOUSPC: return Z80.PREPC.w.l;
	default:
	    if( regnum <= REG_SP_CONTENTS )
	    {
		unsigned offset = _SPD + 2 * (REG_SP_CONTENTS - regnum);
		if( offset < 0xffff )
		return RM( offset ) | ( RM( offset + 1) << 8 );
	    }
    }
    return 0;
}

void cz80_set_reg(int regnum, unsigned val)
{
}

void cz80_set_nmi_line(int state)
{
}

void cz80_set_irq_line(int irqline, int state)
{
}

void cz80_set_irq_callback(int (*callback)(int irqline))
{
}

const char *cz80_info(void *context, int regnum)
{
	switch( regnum )
	{
		case CPU_INFO_NAME: return "cz80";
		case CPU_INFO_FAMILY: return "Motorola 68K";
		case CPU_INFO_VERSION: return "v0.80";
		case CPU_INFO_FILE: return __FILE__;
		case CPU_INFO_CREDITS: return "Copyright 2003-2004 Stephane Dallongeville. All rights reserved";
	}
	return "";
}

unsigned cz80_dasm(char *buffer, unsigned pc)
{
	return 2;
}


/*************************************************/
/**    End MAME interface for cz80              **/
/*************************************************/




void Z80_Reset(Z80_DaisyChain *daisy_chain)
{
	unsigned *ctx=(unsigned *)(((unsigned)cpu_getcontext(cpu_getactivecpu())));
printf("Z80_Reset %i\n",cpu_getactivecpu());
if (daisy_chain)
puts(" Caution !!! Z80_DaisyChain not implementated yet !!!");
	mame4all_cz80_struc=(cz80_struc *)&ctx[4];

	Cz80_Init(mame4all_cz80_struc);
	Cz80_Reset(mame4all_cz80_struc);

	ctx[0]=(unsigned)Cz80_Get_PC(mame4all_cz80_struc);
}

void Z80_GetRegs(Z80_Regs *Regs)
{
	unsigned *ctx=(unsigned *)Regs;
	ctx[0] = (unsigned)Cz80_Get_PC(mame4all_cz80_struc);
}

void Z80_SetRegs (Z80_Regs *Regs)
{
	unsigned *ctx=(unsigned *)Regs;
	mame4all_cz80_struc=(cz80_struc *)&ctx[4];
	Cz80_Set_PC(mame4all_cz80_struc,ctx[0]);
}

unsigned Z80_GetPC (void)
{
	return Cz80_Get_PC(mame4all_cz80_struc);
}

void Z80_Cause_Interrupt(int type)
{
	if (type == Z80_NMI_INT)
		Cz80_Set_NMI(mame4all_cz80_struc);
	else if (type >= 0)
		Cz80_Set_IRQ(mame4all_cz80_struc, type & 0xff);
}

void Z80_Clear_Pending_Interrupts(void)
{
	Cz80_Clear_IRQ(mame4all_cz80_struc);
	Cz80_Clear_NMI(mame4all_cz80_struc);
}


int Z80_Execute(int cycles)
{
/*
static int cuantos=0;
printf("%i Z80_Execute(%i)\n",cuantos++,cycles);
	int falta=cycles;
	do{
		unsigned short nowpc=Cz80_Get_PC(mame4all_cz80_struc);
printf("PC=%.4X (%.2X%.2X%.2X%.2X)/(%.2X%.2X%.2X%.2X)\n",nowpc,OP_ROM[nowpc+0],OP_ROM[nowpc+1],OP_ROM[nowpc+2],OP_ROM[nowpc+3],OP_RAM[nowpc+0],OP_RAM[nowpc+1],OP_RAM[nowpc+2],OP_RAM[nowpc+3]);
//		___z80_hack(nowpc);
//		falta-=Cz80_Exec(mame4all_cz80_struc,1);
		Cz80_Exec(mame4all_cz80_struc,1);
		falta-=6;
	}while(falta>0);
puts("----");
if (cuantos>100) exit(0);
return cycles;
//	return cycles-falta;
*/
	return Cz80_Exec(mame4all_cz80_struc,cycles);
}

