# vim:filetype=mips

# several drawing related functions for Allegrex MIPS
# (c) Copyright 2007, Grazvydas "notaz" Ignotas
# All Rights Reserved

.set noreorder # don't reorder any instructions
.set noat      # don't use $at

.text
.align 4

# void clut8to8(unsigned char *dst, unsigned char *src, unsigned char *pal, int count)

.global clut8to8

clut8to8:
    srl     $a3, 2
amips_clut_loop:
    lbu     $t0, 0($a1)
    lbu     $t1, 1($a1)
    lbu     $t2, 2($a1)
    lbu     $t3, 3($a1)
    sll     $t0, 1
    sll     $t1, 1
    sll     $t2, 1
    sll     $t3, 1
    addu    $t0, $a2
    addu    $t1, $a2
    addu    $t2, $a2
    addu    $t3, $a2
    lbu     $t0, 0($t0)            # Get 1st pixel
    lbu     $t1, 0($t1)            # Get 2nd pixel
    lbu     $t2, 0($t2)            # Get 3rd pixel
    lbu     $t3, 0($t3)            # Get 4th pixel
    sb      $t0, 0($a0)
    sb      $t1, 1($a0)
    sb      $t2, 2($a0)
    sb      $t3, 3($a0)
    addiu   $a0, 4
    addiu   $a3, -1
    bnez    $a3, amips_clut_loop
    addiu   $a1, 4
    jr      $ra
    nop

