#ifndef __dingoo_sound_h__
#define __dingoo_sound_h__

#include <stdlib.h>
#include <stdint.h>
#include <stdio.h>
#include <string.h>
#include <dingoo/ucos2.h>
#include <dingoo/audio.h>
#include <ctype.h>

#define MAX_TASK_DEL_ATTEMPTS 10	// Maximumm attempts to delete task
#define TASK_START_PRIO       6         // Task Priority
#define TASK_STK_SIZE_PLAY    2048      // Size of the Play task's stack (# of WORDs)

#define LOWEST_FPS	    30	    // Lowest frames per second for any game - the lower the FPS the more samples required.
#define SND_MIN_SAMPLE_RATE 8000
#define SND_MAX_SAMPLE_RATE 48000
#define SND_MAX_CHANNELS    2
#define SND_VOLUME_MAX	    30
#define SND_VOLUME_STEP	    1
#define SND_BIT_SZ	    16
#define SND_BYTE_SZ	    2
#define SND_BUFFER_SAMPLES  ((SND_MAX_SAMPLE_RATE/LOWEST_FPS)*SND_MAX_CHANNELS)
#define SND_NBR_BUFFERS	    4

void dingoo_sound_volume(int l, int r);
void dingoo_sound_play(void *, int);
void dingoo_sound_thread_stop();
int dingoo_sound_thread_start(unsigned int, unsigned int, int);
void dingooSoundPause(unsigned int b);
unsigned int dingooSoundIsPaused();
void dingooSoundClearBuffers();
void dingooSoundVolumeIncrease();
void dingooSoundVolumeDecrease();
unsigned int dingooSoundGetVolume();
void dingooSoundSetVolume(unsigned int v);
void _dingooSoundPlay(void *);

#endif
