#include "../vidhrdw/template.c"


#include "driver.h"


static struct MemoryReadAddress readmem[] =
{
	{ -1 }	/* end of table */
};

static struct MemoryWriteAddress writemem[] =
{
	{ -1 }	/* end of table */
};


static struct MemoryReadAddress sound_readmem[] =
{
	{ -1 }	/* end of table */
};

static struct MemoryWriteAddress sound_writemem[] =
{
	{ -1 }	/* end of table */
};



INPUT_PORTS_START( template )
INPUT_PORTS_END



static struct GfxLayout charlayout =
{
	8,8,	/* 8*8 characters */
	2048,	/* 2048 characters */
	2,	/* 2 bits per pixel */
	{ 4, 0 },
	{ 0, 1, 2, 3, 8+0, 8+1, 8+2, 8+3 },
	{ 0*16, 1*16, 2*16, 3*16, 4*16, 5*16, 6*16, 7*16 },
	16*8	/* every char takes 16 consecutive bytes */
};
static struct GfxLayout spritelayout =
{
	16,16,	/* 16*16 sprites */
	2048,	/* 2048 sprites */
	4,	/* 4 bits per pixel */
	{ 2048*64*8+4, 2048*64*8+0, 4, 0 },
	{ 0, 1, 2, 3, 8+0, 8+1, 8+2, 8+3,
			32*8+0, 32*8+1, 32*8+2, 32*8+3, 33*8+0, 33*8+1, 33*8+2, 33*8+3 },
	{ 0*16, 1*16, 2*16, 3*16, 4*16, 5*16, 6*16, 7*16,
			8*16, 9*16, 10*16, 11*16, 12*16, 13*16, 14*16, 15*16 },
	64*8	/* every sprite takes 64 consecutive bytes */
};



static struct GfxDecodeInfo gfxdecodeinfo[] =
{
	{ REGION_GFX1, 0, &charlayout,                  0, 32 },
	{ REGION_GFX2, 0, &fgtilelayout,             32*4, 16 },
	{ -1 } /* end of array */
};


static struct YM2203interface ym2203_interface =
{
	2,              /* 2 chips */
	1500000,        /* 1.5 MHz */
	{ YM2203_VOL(10,15), YM2203_VOL(10,15) },
	{ 0 },
	{ 0 },
	{ 0 },
	{ 0 }
};



static struct MachineDriver machine_driver_template =
{
	/* basic machine hardware */
	{
		{
			CPU_Z80,
			6000000,	/* 6 Mhz */
			readmem,writemem,0,0,
			interrupt,1
		},
		{
			CPU_Z80 | CPU_AUDIO_CPU,
			3000000,	/* 3 Mhz */
			sound_readmem,sound_writemem,0,0,
			interrupt,4
		}
	},
	60, DEFAULT_60HZ_VBLANK_DURATION,	/* frames per second, vblank duration */
	1,	/* 1 CPU slice per frame - interleaving is forced when a sound command is written */
	0,

	/* video hardware */
	32*8, 32*8, { 0*8, 32*8-1, 2*8, 30*8-1 },
	gfxdecodeinfo,
	256,32*4+16*16+16*16+16*16,
	template_vh_convert_color_prom,

	VIDEO_TYPE_RASTER,
	0,
	template_vh_start,
	template_vh_stop,
	template_vh_screenrefresh,

	/* sound hardware */
	0,0,0,0,
	{
		{
			SOUND_YM2203,
			&ym2203_interface
		}
	},
	0 /* nvram handler */
};



/***************************************************************************

  Game driver(s)

***************************************************************************/

ROM_START( template )
	ROM_REGION( 0x30000, REGION_CPU1 )	/* 64k for code + 128k for the banked ROMs images */
	ROM_LOAD( "template.03",      0x20000, 0x10000, 0x3f0ee26c )

	ROM_REGION( 0x10000, REGION_CPU2 )	/* 64k for the audio CPU */
	ROM_LOAD( "template.05",      0x00000, 0x8000, 0xee2bd2d7 )

	ROM_REGION( 0x8000, REGION_GFX1 | REGIONFLAG_DISPOSE )
	ROM_LOAD( "template.04",      0x00000, 0x8000, 0x46cb9d3d )	/* characters */


	ROM_REGION( 0x0c00, REGION_PROMS )
	ROM_LOAD( "bmprom.01",    0x0000, 0x0100, 0x74421f18 )	/* red component */
ROM_END



GAMEX( 1987, template,    0,    template, template, 0, ROT270, "COMPANY", "Template", GAME_NO_COCKTAIL )
GAME ( 1987, template,    0,    template, template, 0, ROT270, "COMPANY", "Template" )
