/***************************************************************************

  RIOT 6532 emulation

***************************************************************************/

#include "memory.h"


struct R6532interface
{
	mem_read_handler portA_r;
	mem_read_handler portB_r;

	mem_write_handler portA_w;
	mem_write_handler portB_w;

	void (*irq_func)(int state);
};


void r6532_init(int n, const struct R6532interface* RI);
void r6532_stop(int n);

READ_HANDLER( r6532_0_r );
READ_HANDLER( r6532_1_r );

WRITE_HANDLER( r6532_0_w );
WRITE_HANDLER( r6532_1_w );

WRITE_HANDLER( r6532_0_PA7_w );	/* for edge detect irq generation; the function checks bit 7 of data */
WRITE_HANDLER( r6532_1_PA7_w );
