#include "driver.h"
#include "vidhrdw/generic.h"

unsigned char *sf1_video_ram;
unsigned char *sf1_object_ram;

int sf1_deltaxb = 0;
int sf1_deltaxm = 0;
int sf1_active  = 0;

WRITE_HANDLER( sf1_deltaxb_w )
{
    //sf1_deltaxm = data;
    COMBINE_WORD_MEM(&sf1_deltaxm,data);
}

WRITE_HANDLER( sf1_deltaxm_w )
{
    //sf1_deltaxb = data;
    COMBINE_WORD_MEM(&sf1_deltaxb,data);
}

void sf1_active_w(int data)
{
    sf1_active = data;
}

inline int sf1_invert(int nb)
{
  static int delta[4] = {0x00, 0x18, 0x18, 0x00};
  return nb^delta[(nb>>3)&3];
}

void sf1_vh_screenrefresh(struct osd_bitmap *bitmap, int full_refresh)
{
  unsigned char *pt;
  short x, y;

  palette_recalc();

  if(sf1_active & 0x20) {
	INT32 offs;
	UINT8 *base = memory_region(REGION_GFX2) + ((sf1_deltaxm >> 4) << 5);

	for (offs = 0; offs < 0x200; offs++, base += 2)
	{
	    INT32 sx = (offs & 0x1f0) - (sf1_deltaxm & 0x0f);
	    INT32 sy = (offs << 4) & 0xf0;

	    if (sx < 49 || sx >= 448 || sy < 16 || sy > 239) continue;

	    INT32 attr  = base[0x10000];
	    INT32 color = base[0x00000];
	    INT32 code  = (base[0x10001] << 8) | base[1];

	    INT32 flipx = attr & 1;
	    INT32 flipy = attr & 2;

	    sx -= 64;
	    //sy -= 16;

	    drawgfx(bitmap,
		    Machine->gfx[0],
		    code,
		    color,
		    flipx, flipy,
		    sx, sy,
		    &Machine->visible_area, TRANSPARENCY_NONE, 0);
	}



  } else
    osd_clearbitmap(bitmap);

  if(sf1_active & 0x40) {
	INT32 offs;
	UINT8 *base = 0x20000+memory_region(REGION_GFX2) + ((sf1_deltaxb >> 4) << 5);

	for (offs = 0; offs < 0x200; offs++, base += 2)
	{
	    INT32 sx = (offs & 0x1f0) - (sf1_deltaxb & 0x0f);
	    INT32 sy = (offs << 4) & 0xf0;

	    if (sx < 49 || sx >= 448 || sy < 16 || sy > 239) continue;

	    INT32 code  = (base[0x10001] << 8) | base[1];
	    INT32 attr  = base[0x10000];
	    INT32 color = base[0x00000];

	    INT32 flipx = attr & 1;
	    INT32 flipy = attr & 2;

	    sx -= 64;
	    //sy -= 16;

	    drawgfx(bitmap,
		    Machine->gfx[1],
		    code,
		    color,
		    flipx, flipy,
		    sx, sy,
		    &Machine->visible_area, TRANSPARENCY_PEN, 15);
	}
  }

  if(sf1_active & 0x80) {
    int zz=0;
    pt = sf1_object_ram + 0x2000-0x40;

    while(pt>=sf1_object_ram) {
      int c, at;
      c = READ_WORD(pt);
      at = READ_WORD(pt+2);
      y = READ_WORD(pt+4);
      x = READ_WORD(pt+6);

      if(x>32 && x<415 && y>-32 && y<288) {
	x -= 64;

	if(!(at&0x400)) {
	  drawgfx(bitmap,
		  Machine->gfx[2],
		  sf1_invert(c),
		  at & 0xf,
		  at & 0x100, at & 0x200,
		  x, y,
		  &Machine->visible_area, TRANSPARENCY_PEN, 15);
	} else {
	  int c1, c2, c3, c4;
	  switch(at & 0x300) {
	  case 0x000:
	  default:
	    c1 = c;
	    c2 = c+1;
	    c3 = c+16;
	    c4 = c+17;
	    break;
	  case 0x100:
	    c1 = c+1;
	    c2 = c;
	    c3 = c+17;
	    c4 = c+16;
	    break;
	  case 0x200:
	    c1 = c+16;
	    c2 = c+17;
	    c3 = c;
	    c4 = c+1;
	    break;
	  case 0x300:
	    c1 = c+17;
	    c2 = c+16;
	    c3 = c+1;
	    c4 = c;
	    break;
	  }
	  drawgfx(bitmap,
		  Machine->gfx[2],
		  sf1_invert(c1),
		  at & 0xf,
		  at & 0x100, at & 0x200,
		  x, y,
		  &Machine->visible_area, TRANSPARENCY_PEN, 15);
	  drawgfx(bitmap,
		  Machine->gfx[2],
		  sf1_invert(c2),
		  at & 0xf,
		  at & 0x100, at & 0x200,
		  x+16, y,
		  &Machine->visible_area, TRANSPARENCY_PEN, 15);
	  drawgfx(bitmap,
		  Machine->gfx[2],
		  sf1_invert(c3),
		  at & 0xf,
		  at & 0x100, at & 0x200,
		  x, y+16,
		  &Machine->visible_area, TRANSPARENCY_PEN, 15);
	  drawgfx(bitmap,
		  Machine->gfx[2],
		  sf1_invert(c4),
		  at & 0xf,
		  at & 0x100, at & 0x200,
		  x+16, y+16,
		  &Machine->visible_area, TRANSPARENCY_PEN, 15);
	}
      }
      pt -= 0x40;
      zz+=0x40;
    }
  }

  if(sf1_active & 8) {
    pt = sf1_video_ram+16;

    for(y=0;y<256;y+=8) {
      for(x=0;x<384;x+=8) {
	int c;
	c=READ_WORD(pt);
	drawgfx(bitmap,
		Machine->gfx[3],
		c & 0x3ff,
		c >> 12,
		c & 0x400, c & 0x800,
		x, y,
		&Machine->visible_area, TRANSPARENCY_PEN, 3);
	pt+=2;
      }
      pt += 32;
    }
  }
}
